> For the complete documentation index, see [llms.txt](https://docs.uninterruptedexception.team/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.uninterruptedexception.team/utils/gamepadex/buttonex.md).

# ButtonEx

<h2 align="center">Methods</h2>

### `pressed()`

Checks if the button is currently pressed.

### `released()`

Checks if the button is currently released.

### `wasJustPressed()`

Only returns true the first tick that you pressed the button.

### `wasJustReleased()`

Only returns true the first tick you released the button.

### `stateJustChanged()`

Returns true if the current state is different from the last.

<h2 align="center">Implementation</h2>

First you need to reference GamepadEx:

```
GamepadEx gamepadEx;
```

And then create your button:

```
ButtonEx A; // this will be the "A" button
```

In `init()`, you need to assign the input to the ButtonEx and GamepadEx:

```
public void init() {
        gamepadEx = new GamepadEx();
        gamepadEx.buttons.add(A = new ButtonEx(gamepad1.a));
    }
```

And now in `loop()` you can call its methods.

At the end of `loop()`, call `gamepadEx.update()`

{% hint style="warning" %}
Do this **Last**.
{% endhint %}

See [ButtonExTest](https://github.com/Gamemanuel/FTCCodingTemplates/blob/8eca65f3f52aba3cf753e8d43f9bd6f86bed9e19/TeamCode/src/main/java/org/firstinspires/ftc/teamcode/Samples/ButtonExTest.java) for an example.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.uninterruptedexception.team/utils/gamepadex/buttonex.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
